\mode<presentation>
% Frame title
\defbeamertemplate*{frametitle}{top box color}[1][greyEPFL]
{
  \begin{beamercolorbox}[wd=\paperwidth,ht=1.2cm]{frametitle}
  \begin{tikzpicture}[overlay,remember picture]
    \begin{scope}[shift={(current page.south west)}]
      % Draw grey rectangle
      \fill[color=#1, anchor=south west] (2cm, 8cm) rectangle (17cm,9cm);
      \node[anchor=west, white,font=\large] at (2cm, 8.75cm){\textbf{\insertframetitle}};
      \node[anchor=west, white,font=\large] at (2cm, 8.25cm){\small\insertframesubtitle};
    \end{scope}
  \end{tikzpicture}
\end{beamercolorbox}
}
\setbeamersize{text margin left=18mm,text margin right=30mm}

% The following is to define an ``exercise'' template for the frames
% It will change the color of the header to redEPFL

% Set the default behavior for each new slide
\BeforeBeginEnvironment{frame}{%
  \setbeamertemplate{frametitle}[top box color]%
}

% Define label for the \begin{frame}[<LABEL>] and define behavior
\makeatletter
\define@key{beamerframe}{exercise}[]{%
  \setbeamertemplate{frametitle}[top box color][redEPFL]%
}
\makeatother

\mode<all>
